JCE в CMS Joomla
JCE в CMS Joomla
Категория: Разработка Теги: Уязвимости Опубликовано: 9 мая 2023

Что за атака index.php?option= com_jce&task=plugin& plugin=imgmanager

Начнем с того, что я нашел в логе nginx такую запись (сайт не этот):

194.38.20.254 - - [28/Apr/2023:07:57:19 +0300] "GET /index.php?option=com_jce&task=plugin&plugin=imgmanager&file=imgmanager&method=form&action=upload HTTP/1.0" 404 299814 "-" "ALittle Client"

Что пытался сделать злоумышленник? 

Безусловно, этот запрос направлен не вручную, а из специальной программы или подготовленного скрипта / бота, но управляет этим человек, поэтому для упрощения я буду говорить именно про этого злоумышленника.

Разберём HTTP-запрос

Строка 404 говорит о том, что запрашиваемый файл не существует и соответственно ему вернулся статус 404 Not found. На самом деле, сам по себе статус 404 не означает, что вектор атаки не сработал - тут нужно повторить запрос и посмотреть, не добавилось ли что-то лишнее в запрос, а в случае со слепыми XSS (Blind XSS) вектор атаки может сработать не в том месте, где ввели команду.

IP-адрес злоумышленника 194.38.20.254 и он принадлежит хостинг-провайдеру или Интернет-провайдеру LLC SmartMediaNetwork, который находится в Ukraine - Dnipropetrovsk Oblast.

В данном запросе вместо версии браузера указано "ALittle Client". Скорее всего это названием ПО, которое купил очередной скрипт-кидди и сканит с его помощью сайты в этих ваших интернетах.

Сам запрос "GET /index.php?option=com_jce&task=plugin&plugin=imgmanager&file=imgmanager&method=form&action=upload HTTP/1.0" говорит о том, что злоумышленник хотел проэксплуатировать уязвимость в Joomla JCE версий 2.6.33 и 2.6.7.1.

В базе AbuseIPDB указано, что данного уже было более 563 атаки на другие сайты.

Технические детали

В компоненте com_jce используется плагин Image Manager, через которой можно удаленно загрузить на сайт файл. CVE для данной уязвимости я не нашел, поэтому точно сказать какие версии подвержены сложно, но скорее всего все версии JCE с 2.6.7.1 по 2.6.33.

Профессионалы ищут такие уязвимости через поисковики, достаточно набрать /index.php?option=com_jce. Однако, "ALittle Client" и поиск такой старой уязвимости говорит о том, что этот злоумышленник является скрипт-кидди, то есть он купил готовое программное обеспечение у хакера и пытается его использовать. Может быть в составе этой программы есть еще что-то, кроме уязвимости, которой от 5 до 10 лет.

Всё просто, методом GET он проверяет возможность эксплуатации уязвимости, и если сервер вернёт 200, тогда он методом POST отправит на сайт файл.

Как защитить веб-сервер?

Немного информации

Скорее всего злоумышленник выполнял сканирование веб-приложения на наличие уязвимостей, используя инструменты для автоматического сканирования уязвимостей.

Любой админ скажет, что реагировать на такие записи в журнале не нужно, но любой опытный пентестер скажет, что реагировать на такие записи в журнале нужно!

Автоматические сканирования на наличие уязвимостей веб-серверов ботами со всего мира - это не просто неприятное явление, но и серьезная угроза для безопасности веб-сервера. Согласно отчету, опубликованному в 2019 году, боты составляют около 37,2% всего трафика Интернета, и это число продолжает расти. Боты, сканирующие веб-серверы, могут искать уязвимости, которые можно использовать для получения несанкционированного доступа к серверу или к данным, которые он содержит.

Теперь скажите честно, последней ли версии у вас всё ПО и библиотеки как на веб-сервере, так и в самом сайте? Уверен, что у большинства будут далеко не последние версии, так как при обновлении много придется настраивать заново. Пора задуматься и понять, что риск не равен нулю.

С чего начинается атака хакера или пентестера на веб-сервер? 

Первым этапом является именно OSINT, но если упростить, то сначала ему нужно собрать информацию. Все прочие виды атак мы опустим, так как тут речь идет о конкретной. В данном случае, злоумышленник собирает информацию о сайте и сервере из открытых источников.

Далее через кучу прокси-серверов сканирует сервер на наличие уязвимостей. При таком сканировании на сервер отправляет множество запросов, но фишка в том, что он использует целый пул прокси-серверов, поэтому каждый 1-2 запроса выполняются с разных IP-адресов. Однако, при частых сканированиях они все будут присутствовать в спам базах.

Если его сканер найдет уязвимость, тогда злоумышленник уже сам будет производить атаку, хотя некоторые так называемые сканирования выполняли через пентестерский фреймворк metasploit методом check.

Рекомендации по противодействию атакам на веб-сервер

Для защиты от автоматических сканирований наличия уязвимостей веб-серверов ботами со всего мира, рекомендуется использовать следующие технические меры защиты на nginx или apache:

  1. Установка модуля ModSecurity: ModSecurity - это модуль для HTTP-сервера Apache, который позволяет обнаруживать и предотвращать атаки на веб-приложения. Он может блокировать запросы, которые соответствуют известным атакам, а также запросы, которые слишком часто повторяются, что может указывать на сканирование.
  2. Использование Fail2ban: Fail2ban - это программное обеспечение, которое может анализировать логи веб-сервера и блокировать IP-адреса, которые слишком часто отправляют запросы на сервер. Это может предотвратить сканирование и другие виды атак на сервер.
  3. Использование CrowdSec: CrowdSec - это бесплатный open source-инструмент для выявления и блокировки вредоносных IP-адресов на основе шаблонов их поведения. Он умеет подключать индивидуальные бан-листы, настроенные администраторами, а также использовать общие бан-листы, в формировании которых принимают участие пользователи CrowdSec.
  4. Настройка Cloudflare или его аналога: Cloudflare - это сервис, который может использоваться в качестве прокси-сервера для вашего веб-сайта. Он может блокировать запросы от известных ботов и других источников нежелательного трафика, а также предоставлять другие инструменты защиты.
  5. Если у вас CMS Joomla и вы используется JCE, тогда следует обновить его до последней версии

Важно блокировать автоматические сканирования на наличие уязвимостей веб-серверов ботами со всего мира, чтобы защитить данные и обеспечить безопасность веб-сервера. Использование рекомендуемых технических мер защиты поможет предотвратить сканирование и другие виды атак, которые могут привести к серьезным последствиям для вашего веб-сервера.

В качестве дополнительных рекомендаций можно назвать весьма очевидные вещи:

  1. Обновлять все используемое ПО на веб-сервере и на промежуточных устройствах до последних версий (включая Joomla и сам JCE).
  2. Обновлять используемые веб-приложениями библиотеки до последних версий.
  3. Производить сканирование на наличие уязвимостей доступными средствами (в Kali Linux для этого множество инструментов).
  4. Использовать средства для аудита кода на безопасность (например, Codacy, Codeac, deepcode или SonarCloud).
  5. Отслеживать новые уязвимости в Vulners - Vulnerability DataBase, NATIONAL VULNERABILITY DATABASE и в Банке данных угроз безопасности информации.
  6. В идеале нужно установить WAF, но такие продукты очень дорогие, а бесплатные неэффективны.

Также можно рассмотреть блокировку посетителей из других стран при помощи GeoIP, но в спорных территориях могут быть неправильные определения, а также необходимо сделать исключения для пула адресов поисковых роботов Google и Bing.

При использовании CMS Joomla зло кроется в плагинах, которые могут не обновляться годами. На самом деле, если хотите достичь хорошего уровня безопасности на этой CMS, тогда следует убрать все лишние плагины, так как даже в обновленном состоянии они с высокой долей вероятности могут содержать уязвимости.

Алексей Черемных
1635